#include "GameObj.hpp"

CGUE17_SneakySteve::scene::GameObj::GameObj(std::string path, Shader * _shader, glm::vec3 physicsCorr, float xRot, float yRot, float zRot, btRigidBody* rigidBody)
	:xRot(xRot), yRot(yRot), zRot(zRot), rigidBody(rigidBody), physicsCorr(physicsCorr)
{
	sceneObj = std::make_unique<SceneObject>(path, _shader);
}

CGUE17_SneakySteve::scene::GameObj::~GameObj()
{
	delete rigidBody;
}

int CGUE17_SneakySteve::scene::GameObj::draw(Shader* shader, glm::mat4 projview)
{

	glm::mat4 modelMat;
	rigidBody->getWorldTransform().getOpenGLMatrix(glm::value_ptr(modelMat));
	modelMat = glm::translate(modelMat,physicsCorr);
	return sceneObj->draw(shader, modelMat, glm::vec3(1,1,1), projview);
}

void CGUE17_SneakySteve::scene::GameObj::update(float time_delta)
{
	btTransform trans;
	rigidBody->getMotionState()->getWorldTransform(trans);

	//get position of rigidbody
	position = glm::vec3(trans.getOrigin().getX(), trans.getOrigin().getY(), trans.getOrigin().getZ())+ physicsCorr;

	//get rotation of rigidbody
	trans.getBasis().getEulerZYX(zRot, yRot, xRot);

	//std::cout << "sphere height: " << trans.getOrigin().getY() << std::endl;
	



}
