#pragma once
#include <glm/glm.hpp>

#include <iostream>
#include <memory>
#include <glm/gtc/matrix_transform.hpp>

#include "../Scene/SceneObject.hpp"
#include <btBulletDynamicsCommon.h>

namespace CGUE17_SneakySteve {
	namespace scene {
		class GameObj
		{
		public:
			GameObj() {};
			GameObj(std::string path, sneakystv::Shader* _shader, glm::vec3 physicsCorr, float xRot, float yRot, float zRot, btRigidBody* rigidBody);
			~GameObj();

			virtual int draw(Shader* shader, glm::mat4 projview);
			virtual void update(float time_delta);

			std::unique_ptr<SceneObject> sceneObj;
			btRigidBody* rigidBody;

			glm::vec3 position;
			glm::vec3 physicsCorr;
			float xRot;
			float yRot;
			float zRot;

			glm::mat4 modelMat;


		private:
			
			
		};


	}
}
