#include "Laser.h"

CGUE17_SneakySteve::scene::Laser::Laser(std::string path, sneakystv::Shader * _shader, glm::vec3 physicsCorr, float xRot, float yRot, float zRot, btRigidBody * rigidBody, Camera * camera)
	:GameObj(path, _shader, physicsCorr, xRot, yRot, zRot, rigidBody),id(1)
{
	particle = new ParticleSpawner(Shaderholder::getShader(SHADER_PARTICLE), camera);
}

CGUE17_SneakySteve::scene::Laser::~Laser()
{
}

void CGUE17_SneakySteve::scene::Laser::update(float time_delta)
{
	btTransform trans;
	rigidBody->getMotionState()->getWorldTransform(trans);

	//particle Spawner update
	particle->update(time_delta);
	particle->position = glm::vec3(trans.getOrigin().getX(), trans.getOrigin().getY(), trans.getOrigin().getZ());
}

int CGUE17_SneakySteve::scene::Laser::draw(Shader * shader, glm::mat4 projview)
{
	glm::mat4 modelMat;
	rigidBody->getWorldTransform().getOpenGLMatrix(glm::value_ptr(modelMat));
	modelMat = glm::translate(modelMat, physicsCorr);
	
	if (shader != Shaderholder::getShader(SHADER_SHADOW))
	{
		particle->Draw();
		shader->useShader();
	}
	return sceneObj->draw(shader, modelMat, glm::vec3(1, 0, 0), projview);
}

int CGUE17_SneakySteve::scene::Laser::getId()
{
	return id;
}
