#pragma once

#include "GameObj.hpp"
#include "../Scene/Camera.hpp"
#include <btBulletDynamicsCommon.h>

namespace CGUE17_SneakySteve {
	namespace scene {
		class Player:public GameObj
		{
		public:
			Player() {};
			Player(std::string path, sneakystv::Shader* _shader, glm::vec3 physicsCorr, float xRot, float yRot, float zRot, btRigidBody* rigidBody, Camera* camera);
			~Player();

			int draw(Shader* shader, glm::mat4 projview);
			void update(float time_delta);
			glm::vec3 getFront();

			//glm::mat4 getCamMat();

			

			void translate(float x, float y, float z);
			void rotate(double x, double y);
			void jump();


		private:
			Camera* camera;

		};


	}
}
