#pragma once

#include <btBulletDynamicsCommon.h>
#include <GL/glew.h>
#include <glm/glm.hpp>
#include <vector>
#include <map>
#include <iostream>
#include <memory>
#include <glm/gtc/matrix_transform.hpp>
#include <glm/gtc/type_ptr.hpp>
#include "Scene\SceneObject.hpp"
#include "Scene\Camera.hpp"
#include "Scene\Mesh.hpp"

class PhysicsManager
{
	public:
		PhysicsManager();
		virtual ~PhysicsManager();
		void addPhysicsObject(char type, btScalar transform[], btScalar mass, glm::vec3 inertia);
		glm::vec3 movePlayer(glm::vec3 cameraPosition, /*glm::vec3 playerPos,*/ float time_delta);
		bool moveObjects(float* model, std::unique_ptr<Camera> player);
	private:
		btBroadphaseInterface* broadphase;
		btDefaultCollisionConfiguration* collisionConfiguration;
		btCollisionDispatcher* dispatcher;
		btSequentialImpulseConstraintSolver* solver;
		btDiscreteDynamicsWorld* dynamicsWorld;

		btCollisionShape* groundShape;
		btCollisionShape* fallShape;
		btDefaultMotionState* groundMotionState;
		btRigidBody* groundRigidBody;
		btDefaultMotionState* fallMotionState;
		btScalar mass;
		btRigidBody* fallRigidBody;

		btAlignedObjectArray<btCollisionShape*> collisionShapes;
		btAlignedObjectArray<btRigidBody*> rigidBodys;
		btRigidBody* playerRigidBody;
};