#include "Camera.hpp"

#include <iostream>
#include <fstream>
#include <memory>
#include <glm/gtc/matrix_transform.hpp>

using namespace sneakystv;
using namespace std;

Camera::Camera(glm::vec3& position, float fov, int height, int width, float near, float far)
	:position(position), projectionMat(0),camFront(0), camUp(0), xlast(0), ylast(0), pitch(0), yaw(-90)
{
	projectionMat = glm::perspective(fov, (float)width / (float)height, near, far);
	camFront = glm::vec3(0.0f, 0.0f, -1.0f);
	camUp = glm::vec3(0.0f, 1.0f, 0.0f);
}

Camera::~Camera()
{
	
}

void Camera::translate(float x, float y, float z)
{
	position += camFront*x;
	position += glm::normalize(glm::cross(camFront, camUp))*y;
	int i = 0;
}

void Camera::rotate(double mousex, double mousey)
{
	GLfloat xoffset = mousex - xlast;
	GLfloat yoffset = ylast - mousey; // Reversed since y-coordinates range from bottom to top
	
	

	if (xlast == 0 && ylast == 0)
	{
		xoffset == 0;
		yoffset == 0; 
		xlast = mousex;
		ylast = mousey;
		return;
	}
	xlast = mousex;
	ylast = mousey;

	GLfloat sensitivity = 0.005f;
	xoffset *= sensitivity;
	yoffset *= sensitivity;

	yaw += xoffset;
	pitch += yoffset;

	if (pitch > 89.0f)
		pitch = 89.0f;
	if (pitch < -89.0f)
		pitch = -89.0f;

	glm::vec3 front;
	front.x = cos(pitch) * cos(yaw);
	front.y = sin(pitch);
	front.z = cos(pitch) * sin(yaw);
	
	camFront = glm::normalize(front);

}

glm::mat4& Camera::getProjectionMatrix()
{
	return projectionMat;
}

glm::mat4& Camera::getViewMatrix()
{
	return glm::lookAt(position, position + camFront, camUp);
}

glm::mat4& Camera::getCameraMatrix()
{
	return projectionMat *  glm::lookAt(position, position + camFront, camUp);
}

glm::vec3 sneakystv::Camera::getCamFront()
{
	return glm::vec3(camFront.x, camFront.y, camFront.z);
	
}


