#pragma once

#include <string>
#include <memory>
#include <sstream>
#include <GL\glew.h>
#include <GLFW\glfw3.h>
#include <glm/glm.hpp>
#include <glm/gtx/transform.hpp>
#include <glm/gtc/matrix_transform.hpp>
#include <glm/gtc/quaternion.hpp>
#include <glm/gtx/quaternion.hpp>
#include <glm/gtx/rotate_vector.hpp>
#include <btBulletDynamicsCommon.h>
#include "SceneObject.hpp"

namespace sneakystv
{
	class Camera
	{
	public:
		Camera(glm::vec3& position, float fov, int height, int width, float near, float far);
		~Camera();

		void translate(float x, float y, float z);
		void rotate(double x, double y);

		glm::mat4& getProjectionMatrix();
		glm::mat4& getViewMatrix();
		glm::mat4& getCameraMatrix();
		glm::vec3 getCamFront();

		//position
		glm::vec3 position;

		GLfloat yaw;
		GLfloat pitch;
	private:

		int xlast;
		int ylast;
		

		glm::mat4 projectionMat;

		glm::vec3 camFront;
		glm::vec3 camUp;

		btRigidBody* rigidBody;
	
	};
}