#pragma once

#include <GL/glew.h>
#include <GLFW/glfw3.h>
#include <glm\glm.hpp>
#include <vector>
#include "../Recources/Shader.hpp"
#include <glm/gtc/type_ptr.hpp>

namespace CGUE17_SneakySteve
{
	namespace scene {
		struct Vertex {
			glm::vec3 Position;
			glm::vec3 Normal;
			glm::vec2 TexCoords;
		};

		struct Texture {
			GLuint id;
			std::string type;
		};


		class Mesh {
		public:
			/*  Mesh Data  */
			std::vector<Vertex> vertices;
			std::vector<GLuint> indices;
			std::vector<Texture> textures;
			/*  Functions  */
			Mesh(std::vector<Vertex> vertices, std::vector<GLuint> indices, std::vector<Texture> textures);
			void Draw(sneakystv::Shader* shader);
			/* AABB */
			glm::vec3 minAABB;
			glm::vec3 maxAABB;
		private:
			/*  Render data  */
			GLuint VAO, VBO, EBO;
			/*  Functions    */
			void setupMesh();
		};
	}
}