#pragma once

#include <GL/glew.h>
#include <GLFW/glfw3.h>
#include <glm\glm.hpp>
#include <vector>
#include "../Recources/Shader.hpp"
#include "Mesh.hpp"
#include <assimp\Importer.hpp>
#include <assimp\scene.h>
#include <assimp\postprocess.h>
#include <vector>
#include <glm\common.hpp>

#include<GLFW\glfw3.h>
#include<GL\glew.h>
#include "..\Util\FrustumCulling.hpp"

using namespace std;
using namespace sneakystv;

namespace CGUE17_SneakySteve
{
	namespace scene 
	{
		class Model
		{
		public:
			Model()
			{

			};
			/*  Functions   */
			
			Model(string/*GLchar**/ path, Shader* shader);
			int Draw(Shader* shader, glm::mat4 modelmat, glm::vec3 color, glm::mat4 projview);

			/* AABB */
			glm::vec3 minAABB;
			glm::vec3 maxAABB;
			bool frustumTestBox(glm::mat4 mvp, glm::vec3 minAABB, glm::vec3 maxAABB);
		private:
			/*  Model Data  */
			vector<Mesh> meshes;
			string directory;
			/*  Functions   */
			bool loadModel(string path, Shader* shader);
			void processNode(aiNode* node, const aiScene* scene, Shader* shader);
			Mesh processMesh(aiMesh* mesh, const aiScene* scene, Shader* shader);
			vector<Texture> loadMaterialTextures(aiMaterial* mat, aiTextureType type,
				string typeName, Shader* shader);
			GLuint TextureFromFile(const char* path, Shader* shader);
		};
	}
}