#pragma once

#include "../Recources/Shader.hpp"
#include "../Scene/Camera.hpp"
#include <glm\glm.hpp>
#include <vector>
#include "Mesh.hpp"
#include <algorithm>




using namespace std;
using namespace sneakystv;

namespace CGUE17_SneakySteve
{
	namespace scene
	{
		class ParticleSpawner
		{
			
		public:
			ParticleSpawner()
			{

			};
			/*  Functions   */
			ParticleSpawner(Shader* shader, Camera* camera);
			void update(float deltaT);
			void Draw();

			glm::vec3 position;
		private:
			int FindUnusedParticle();
			void SortParticles();

			const int MaxParticles = 200;
			GLuint VAO;
			GLuint particles_vertex_VBO;
			GLuint particles_position_VBO;
			GLuint particles_color_VBO;

			int LastUsedParticle = 0;

			GLfloat* g_particule_position_size_data = new GLfloat[MaxParticles * 4];
			GLubyte* g_particule_color_data = new GLubyte[MaxParticles * 4];

			Camera* camera;
			Shader* shader;
			
		};
	}
}