#include "SceneObject.hpp"
#include "Model.hpp"

#include <glm/gtc/matrix_transform.hpp>

using namespace CGUE17_SneakySteve::scene;

SceneObject::SceneObject(std::string path, Shader* _shader)
	: shader(_shader)
{
	//For normal Object loading without indices
	//bool res = loadOBJ("cube.obj", vertices, uvs, normals);
	//Assimp:
	model = Model::Model(path, _shader);
	/*
	glGenBuffers(1, &vertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, vertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, indexed_vertices.size() * sizeof(glm::vec3), &indexed_vertices[0], GL_STATIC_DRAW);

	glGenBuffers(1, &uvBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, uvBuffer);
	glBufferData(GL_ARRAY_BUFFER, indexed_uvs.size() * sizeof(glm::vec2), &indexed_uvs[0], GL_STATIC_DRAW);

	glGenBuffers(1, &normalBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, normalBuffer);
	glBufferData(GL_ARRAY_BUFFER, indexed_normals.size() * sizeof(glm::vec3), &indexed_normals[0], GL_STATIC_DRAW);

	//A buffer for the indices
	glGenBuffers(1, &elementBuffer);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, elementBuffer);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, indices.size() * sizeof(unsigned short), &indices[0], GL_STATIC_DRAW);
	*/

}

SceneObject::~SceneObject()
{
	glDeleteBuffers(1, &positionBuffer);
	glDeleteBuffers(1, &indexBuffer);
	glDeleteBuffers(1, &uvsBuffer);
	glDeleteBuffers(1, &normalsBuffer);
}

int CGUE17_SneakySteve::scene::SceneObject::draw(Shader* shader, glm::mat4 modelMat, glm::vec3 color, glm::mat4 projview)
{
	
	return model.Draw(shader, modelMat, color, projview);
}

void CGUE17_SneakySteve::scene::SceneObject::update(float time_delta)
{
}
