#pragma once

#include <glm\glm.hpp>

#include "../Recources/Shader.hpp"
#include "Model.hpp"
#include "..\Util\FrustumCulling.hpp"


namespace CGUE17_SneakySteve {
	namespace scene {
		class SceneObject
		{
		public:
			SceneObject(){};
			SceneObject(std::string path, Shader* _shader);
			~SceneObject();

			int draw(Shader* shader,glm::mat4 modelMat, glm::vec3 color, glm::mat4 projview);
			void update(float time_delta);

			Model model;


		private:
		
			Shader* shader;

			//For normal Object loading without indices
			std::vector<glm::vec3> normals;
			std::vector<glm::vec2> uvs;
			std::vector<glm::vec3> vertices;

			//For Assimp
			std::vector<unsigned short> indices;
			std::vector<glm::vec3> indexed_vertices;
			std::vector<glm::vec2> indexed_uvs;
			std::vector<glm::vec3> indexed_normals;

			//For Normal Object loading without indices
			GLuint positionBuffer, verticesBuffer, normalsBuffer, uvsBuffer, indexBuffer;

			//For Assimp:
			GLuint vertexBuffer, normalBuffer, uvBuffer, elementBuffer;
		};


	}
}
#define SCENE_OBJECT