#version 330

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;

uniform mat4 model;
uniform mat4 proj;
uniform mat4 depthBiasMVP;

out vec3 Normal;
out vec3 FragPos;
out vec4 shadowCoord;


void main()
{
	gl_Position = proj * model * vec4(position, 1);
	FragPos = vec3(model * vec4(position, 1.0f));
	Normal =  mat3(transpose(inverse(model))) * normal;
	shadowCoord = depthBiasMVP * model * vec4(position,1);
}