#version 330 core
out vec4 FragColor;

in vec2 TexCoords;

uniform sampler2D scene;
uniform sampler2D bloomBlur;
uniform bool bloom;



void main()
{        
	float exposure = 1.0;     
    const float gamma = 2.2;
    vec3 hdrColor = texture(scene, TexCoords).rgb;      
    vec3 bloomColor = texture(bloomBlur, TexCoords).rgb;
	bloomColor -= vec3(0.4,0.4,0.4);
    
	if(bloom)
        hdrColor += bloomColor; // additive blending
    
    

    FragColor = vec4(hdrColor, 1.0);
}