#version 330

in vec2 TexCoords;
in vec3 Normal;
in vec3 FragPos;

out vec4 fragColor;

uniform sampler2D texture_diffuse;

uniform vec3 lightPos;

void main()
{
	vec3 norm = normalize(Normal);
	vec3 lightDir = normalize(lightPos - FragPos);
	float diff = max(dot(norm,lightDir),0.1);
	vec4 diffuse = diff * (texture(texture_diffuse, TexCoords));

	fragColor = diffuse;
}