#version 330

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

uniform mat4 model;
uniform mat4 proj;

out vec2 TexCoords;
out vec3 Normal;
out vec3 FragPos;


void main()
{
	gl_Position = proj * model * vec4(position, 1);
	FragPos = vec3(model * vec4(position, 1.0f));
	TexCoords = texCoords;
	Normal =  mat3(transpose(inverse(model))) * normal;
}