#include "BulletDebugDrawer.h"




void BulletDebugDrawer::drawLine(const btVector3 &from, const btVector3 &to, const btVector3 &color)
{
	LINES.push_back(_LINE(glm::vec3(from.getX(), from.getY(), from.getZ()), glm::vec3(to.getX(), to.getY(), to.getZ())));
}

BulletDebugDrawer::BulletDebugDrawer()
{
}

BulletDebugDrawer::~BulletDebugDrawer()
{
}

void BulletDebugDrawer::drawContactPoint(const btVector3 &pointOnB, const btVector3 &normalOnB, btScalar distance, int lifeTime, const btVector3 &color)
{


}

void BulletDebugDrawer::ToggleDebugFlag(int flag) {
	// checks if a flag is set and enables/
	// disables it
	if (m_debugMode & flag)
	// flag is enabled, so disable it
	m_debugMode = m_debugMode & (~flag);
	else
	// flag is disabled, so enable it
	m_debugMode |= flag;
}

void BulletDebugDrawer::doDrawing()
{
	glGenVertexArrays(1, &vao);
	glBindVertexArray(vao);

	glGenBuffers(1, &vbo);
	glBindBuffer(GL_ARRAY_BUFFER, vbo);
	glBufferData(GL_ARRAY_BUFFER, LINES.size() * sizeof(_LINE), &LINES[0], GL_STATIC_DRAW);
	glVertexAttribPointer((GLuint)0, 3, GL_FLOAT, GL_FALSE, 0, 0);
	glEnableVertexAttribArray(0);

	glBindVertexArray(0);
	glBindBuffer(GL_ARRAY_BUFFER, 0);

}

void BulletDebugDrawer::cleanDrawing()
{
	LINES.clear();

	
	glDeleteBuffers(1, &vbo);
	glDeleteVertexArrays(1, &vao);
}


