#pragma once

#include <btBulletDynamicsCommon.h>
#include "../Recources/Shader.hpp"
#include <vector>
#include <GL/glew.h>
#include <GLFW/glfw3.h>
#include <glm/glm.hpp>
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>
#include "LinearMath/btIDebugDraw.h"
#include <stdlib.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GLFW/glfw3.h>

class BulletDebugDrawer : public btIDebugDraw {
public:
	BulletDebugDrawer();
	~BulletDebugDrawer();

	struct  _LINE{
		glm::vec3 from;
		glm::vec3 to;

		_LINE(glm::vec3 f, glm::vec3 t){
			from = f;
			to = t;
		}
	};

	int m_debugMode;

	std::vector<_LINE> LINES;

	GLuint vao, vbo;

	virtual void setDebugMode(int debugMode) override { m_debugMode = debugMode; }
	virtual int getDebugMode() const override { return m_debugMode; }

	virtual void  drawContactPoint(const btVector3 &pointOnB, const btVector3 &normalOnB, btScalar distance, int lifeTime, const btVector3 &color) override;
	virtual void  drawLine(const btVector3 &from, const btVector3 &to, const btVector3 &color) override;
	virtual void  reportErrorWarning(const char* warningString) override {}
	virtual void  draw3dText(const btVector3 &location, const char* textString) override {}
	void ToggleDebugFlag(int flag);

	void doDrawing();
	void cleanDrawing();




};
