#include "LvlLoader.hpp"

using namespace CGUE17_SneakySteve::scene;

bool sneakystv::LvlLoader::loadLvl(int lvl, std::vector<Shader*>* shaders, std::vector<std::vector<std::unique_ptr<CGUE17_SneakySteve::scene::GameObj>>>* worldobjs, std::vector<CGUE17_SneakySteve::scene::GameObj*>* enemys, btDiscreteDynamicsWorld* dynamicsWorld, Camera* camera)
{
	switch (lvl) {
	case(1):
	{
				
		btCollisionShape* groundShape = new btStaticPlaneShape(btVector3(0, 1, 0), 1);
		btDefaultMotionState* groundMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 0, 0, 1), btVector3(0, -1, 0)));
		btRigidBody::btRigidBodyConstructionInfo groundRigidBodyCI(0, groundMotionState, groundShape, btVector3(0, 0, 0));
		btRigidBody* groundRigidBody = new btRigidBody(groundRigidBodyCI);
		dynamicsWorld->addRigidBody(groundRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testarea.obj", shaders->at(0), glm::vec3(0,1,0), 0, 0, 0, groundRigidBody));

		//Wall 1
		btVector3 boxHalf = btVector3(28.3, 3.3, 0.25);
		btCollisionShape* fallShape = new btBoxShape(boxHalf);
		btDefaultMotionState* fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 0, 0, 1), btVector3(0, 3,-28)));
		btRigidBody::btRigidBodyConstructionInfo fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		btRigidBody* fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));

		boxHalf = btVector3(28.3, 3.3, 0.25);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 0, 0, 1), btVector3(0, 3, 28)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));

		boxHalf = btVector3(28.3, 3.3, 0.25);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 1, 0, 1), btVector3(28, 3, 0)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));

		boxHalf = btVector3(28.3, 3.3, 0.25);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 1, 0, 1), btVector3(-28, 3, -28)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));

		boxHalf = btVector3(28.3, 3.3, 0.25);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 0, 0, 1), btVector3(-28, 3, 28)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));

		boxHalf = btVector3(28.3, 3.3, 0.25);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 1, 0, 1), btVector3(-56, 3, 0)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));

		boxHalf = btVector3(28.3, 3.3, 0.25);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 1, 0, 1), btVector3(-56, 3, -56)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));

		boxHalf = btVector3(28.3, 3.3, 0.25);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 0, 0, 1), btVector3(-28, 3, -84)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));

		boxHalf = btVector3(28.3, 3.3, 0.25);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 1, 0, 1), btVector3(0, 3, -56)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(0).push_back(make_unique<GameObj>("Recources/Models/testareaWall.obj", shaders->at(0), glm::vec3(0, -3, -0.1), 0, 0, 0, fallRigidBody));


		//WardenTest
		boxHalf = btVector3(0.75, 1.75, 0.75);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 0, 0, 1), btVector3(10, 2, 10)));
		btScalar mass = 1;
		btVector3 fallInertia = btVector3(0, 0, 0);
		fallShape->calculateLocalInertia(mass, fallInertia);
		fallRigidBodyCI= btRigidBody::btRigidBodyConstructionInfo(mass, fallMotionState, fallShape, fallInertia);
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		std::vector<glm::vec2> waypts;
		waypts.push_back(glm::vec2(25, 25));
		waypts.push_back(glm::vec2(-25, 25));
		waypts.push_back(glm::vec2(-25, -25));
		waypts.push_back(glm::vec2(25, -25));
		std::unique_ptr<Warden> warden = make_unique<Warden>("Recources/Models/warden.obj", shaders->at(0), glm::vec3(0, -1.5, 0), 0, 0, 0, fallRigidBody, waypts, camera);
		enemys->push_back(warden.get());
		worldobjs->at(0).push_back(std::move(warden));

		//Laser test
		boxHalf = btVector3(0.1, 0.1, 8.5);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 1, 0, 1), btVector3(-42, 0.25, -5)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		std::unique_ptr<Laser> laser = make_unique<Laser>("Recources/Models/laser.obj", shaders->at(0), glm::vec3(0, 0, 0), 0, 0, 0, fallRigidBody, camera);
		enemys->push_back(laser.get());
		worldobjs->at(0).push_back(std::move(laser));

		//Laser test
		boxHalf = btVector3(0.1, 0.1, 8.5);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 1, 0, 1), btVector3(-42, 0.25, -25)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		laser = make_unique<Laser>("Recources/Models/laser.obj", shaders->at(0), glm::vec3(0, 0, 0), 0, 0, 0, fallRigidBody, camera);
		enemys->push_back(laser.get());
		worldobjs->at(0).push_back(std::move(laser));

		//Laser test
		boxHalf = btVector3(0.1, 0.1, 8.5);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 1, 0, 1), btVector3(-42, 0.25, -45)));
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(0, fallMotionState, fallShape, btVector3(0, 0, 0));
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		laser = make_unique<Laser>("Recources/Models/laser.obj", shaders->at(0), glm::vec3(0, 0, 0), 0, 0, 0, fallRigidBody, camera);
		enemys->push_back(laser.get());
		worldobjs->at(0).push_back(std::move(laser));

		

		boxHalf = btVector3(1, 1,1);
		fallShape = new btBoxShape(boxHalf);
		fallMotionState = new btDefaultMotionState(btTransform(btQuaternion(0, 0, 0, 1), btVector3(5, 10, 5)));
		mass = 1;
		fallInertia = btVector3(0, 0, 0);
		fallShape->calculateLocalInertia(mass, fallInertia);
		fallRigidBodyCI = btRigidBody::btRigidBodyConstructionInfo(mass, fallMotionState, fallShape, fallInertia);
		fallRigidBody = new btRigidBody(fallRigidBodyCI);
		dynamicsWorld->addRigidBody(fallRigidBody);
		worldobjs->at(1).push_back(make_unique<GameObj>("Recources/Models/texCube.obj", shaders->at(1), glm::vec3(0, 0, 0), 0, 0, 0, fallRigidBody));

		//safe


		break;
	}
	default: 
	{
		printf("No lvl: %i \n", lvl);
		return false;
	}
	}

	return true;
}
